/* midori-uri.c generated by valac 0.10.4, the Vala compiler
 * generated from midori-uri.vala, do not modify */

/*
 Copyright (C) 2011 Christian Dywan <christian@twotoasts.de>

 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.

 See the file COPYING for the full license text.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define MIDORI_TYPE_URI (midori_uri_get_type ())
#define MIDORI_URI(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MIDORI_TYPE_URI, MidoriURI))
#define MIDORI_URI_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MIDORI_TYPE_URI, MidoriURIClass))
#define MIDORI_IS_URI(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MIDORI_TYPE_URI))
#define MIDORI_IS_URI_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MIDORI_TYPE_URI))
#define MIDORI_URI_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MIDORI_TYPE_URI, MidoriURIClass))

typedef struct _MidoriURI MidoriURI;
typedef struct _MidoriURIClass MidoriURIClass;
typedef struct _MidoriURIPrivate MidoriURIPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MidoriURI {
	GObject parent_instance;
	MidoriURIPrivate * priv;
};

struct _MidoriURIClass {
	GObjectClass parent_class;
};


static gpointer midori_uri_parent_class = NULL;

char* g_hostname_to_unicode (const char* hostname);
char* g_hostname_to_ascii (const char* hostname);
GType midori_uri_get_type (void) G_GNUC_CONST;
enum  {
	MIDORI_URI_DUMMY_PROPERTY
};
char* midori_uri_parse_hostname (const char* uri, char** path);
char* midori_uri_parse (const char* uri, char** path);
char* midori_uri_to_ascii (const char* uri);
char* midori_uri_unescape (const char* uri);
char* midori_uri_format_for_display (const char* uri);
char* midori_uri_for_search (const char* uri, const char* keywords);
gboolean midori_uri_is_blank (const char* uri);
gboolean midori_uri_is_http (const char* uri);
gboolean midori_uri_is_resource (const char* uri);
gboolean midori_uri_is_location (const char* uri);
gboolean midori_uri_is_email (const char* uri);
gboolean midori_uri_is_ip_address (const char* uri);
gboolean midori_uri_is_valid (const char* uri);
GChecksumType midori_uri_get_fingerprint (const char* uri, char** checksum, char** label);
MidoriURI* midori_uri_new (void);
MidoriURI* midori_uri_construct (GType object_type);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);
static int _vala_strcmp0 (const char * str1, const char * str2);



#line 19 "midori-uri.vala"
char* midori_uri_parse_hostname (const char* uri, char** path) {
#line 80 "midori-uri.c"
	char* result = NULL;
	const char* hostname;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	if (path != NULL) {
		*path = NULL;
	}
#line 21 "midori-uri.vala"
	if (uri == NULL) {
#line 90 "midori-uri.c"
		result = g_strdup (uri);
#line 22 "midori-uri.vala"
		return result;
#line 94 "midori-uri.c"
	}
#line 23 "midori-uri.vala"
	hostname = g_utf8_strchr (uri, (gssize) (-1), (gunichar) '/');
#line 24 "midori-uri.vala"
	if (hostname == NULL) {
#line 24 "midori-uri.vala"
		_tmp1_ = TRUE;
#line 102 "midori-uri.c"
	} else {
#line 24 "midori-uri.vala"
		_tmp1_ = g_utf8_get_char (g_utf8_offset_to_pointer (hostname, 1)) != '/';
#line 106 "midori-uri.c"
	}
#line 24 "midori-uri.vala"
	if (_tmp1_) {
#line 24 "midori-uri.vala"
		_tmp0_ = TRUE;
#line 112 "midori-uri.c"
	} else {
#line 25 "midori-uri.vala"
		_tmp0_ = g_utf8_strchr (hostname, (gssize) (-1), (gunichar) ' ') != NULL;
#line 116 "midori-uri.c"
	}
#line 24 "midori-uri.vala"
	if (_tmp0_) {
#line 120 "midori-uri.c"
		result = NULL;
#line 26 "midori-uri.vala"
		return result;
#line 124 "midori-uri.c"
	}
#line 27 "midori-uri.vala"
	hostname = g_utf8_offset_to_pointer (hostname, (glong) 2);
#line 28 "midori-uri.vala"
	if ((path) != NULL) {
#line 130 "midori-uri.c"
		char* _tmp2_;
#line 29 "midori-uri.vala"
		if ((*path = (_tmp2_ = g_strdup (g_utf8_strchr (hostname, (gssize) (-1), (gunichar) '/')), _g_free0 (*path), _tmp2_)) != NULL) {
#line 134 "midori-uri.c"
			char** _tmp3_;
			char** _tmp4_;
			gint _tmp4__length1;
			char* _tmp5_;
			result = (_tmp5_ = g_strdup ((_tmp4_ = _tmp3_ = g_strsplit (hostname, "/", 0), _tmp4__length1 = _vala_array_length (_tmp3_), _tmp4_)[0]), _tmp4_ = (_vala_array_free (_tmp4_, _tmp4__length1, (GDestroyNotify) g_free), NULL), _tmp5_);
#line 30 "midori-uri.vala"
			return result;
#line 142 "midori-uri.c"
		}
	}
	result = g_strdup (hostname);
#line 32 "midori-uri.vala"
	return result;
#line 148 "midori-uri.c"
}


#line 35 "midori-uri.vala"
char* midori_uri_parse (const char* uri, char** path) {
#line 154 "midori-uri.c"
	char* result = NULL;
	char* _tmp0_ = NULL;
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
#line 35 "midori-uri.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 162 "midori-uri.c"
	if (path != NULL) {
		*path = NULL;
	}
#line 36 "midori-uri.vala"
	_tmp3_ = (_tmp1_ = midori_uri_parse_hostname (uri, &_tmp0_), *path = (_tmp2_ = _tmp0_, _g_free0 (*path), _tmp2_), _tmp1_);
#line 36 "midori-uri.vala"
	if (_tmp3_ == NULL) {
#line 170 "midori-uri.c"
		char* _tmp4_;
#line 36 "midori-uri.vala"
		_tmp3_ = (_tmp4_ = g_strdup (uri), _g_free0 (_tmp3_), _tmp4_);
#line 174 "midori-uri.c"
	}
	result = _tmp3_;
#line 36 "midori-uri.vala"
	return result;
#line 179 "midori-uri.c"
}


#line 38 "midori-uri.vala"
char* midori_uri_to_ascii (const char* uri) {
#line 185 "midori-uri.c"
	char* result = NULL;
	char* proto;
	gboolean _tmp0_ = FALSE;
	char* path;
	char* _tmp4_ = NULL;
	char* _tmp5_;
	char* _tmp6_;
	char* _tmp7_;
	char* hostname;
	char* encoded;
#line 38 "midori-uri.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 40 "midori-uri.vala"
	proto = NULL;
#line 41 "midori-uri.vala"
	if (g_utf8_strchr (uri, (gssize) (-1), (gunichar) '/') != NULL) {
#line 41 "midori-uri.vala"
		_tmp0_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) ':') != NULL;
#line 204 "midori-uri.c"
	} else {
#line 41 "midori-uri.vala"
		_tmp0_ = FALSE;
#line 208 "midori-uri.c"
	}
#line 41 "midori-uri.vala"
	if (_tmp0_) {
#line 212 "midori-uri.c"
		char** _tmp1_;
		char** _tmp2_;
		gint _tmp2__length1;
		char* _tmp3_;
#line 42 "midori-uri.vala"
		proto = (_tmp3_ = g_strdup ((_tmp2_ = _tmp1_ = g_strsplit (uri, "://", 0), _tmp2__length1 = _vala_array_length (_tmp1_), _tmp2_)[0]), _g_free0 (proto), _tmp3_);
#line 219 "midori-uri.c"
		_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
	}
#line 43 "midori-uri.vala"
	path = NULL;
#line 44 "midori-uri.vala"
	_tmp7_ = (_tmp5_ = midori_uri_parse_hostname (uri, &_tmp4_), path = (_tmp6_ = _tmp4_, _g_free0 (path), _tmp6_), _tmp5_);
#line 44 "midori-uri.vala"
	if (_tmp7_ == NULL) {
#line 228 "midori-uri.c"
		char* _tmp8_;
#line 44 "midori-uri.vala"
		_tmp7_ = (_tmp8_ = g_strdup (uri), _g_free0 (_tmp7_), _tmp8_);
#line 232 "midori-uri.c"
	}
#line 44 "midori-uri.vala"
	hostname = g_strdup (_tmp7_);
#line 45 "midori-uri.vala"
	encoded = g_hostname_to_ascii (hostname);
#line 46 "midori-uri.vala"
	if (encoded != NULL) {
#line 240 "midori-uri.c"
		char* _tmp9_;
		const char* _tmp11_;
		char* _tmp12_;
		char* _tmp13_;
		char* _tmp14_;
#line 47 "midori-uri.vala"
		_tmp9_ = g_strdup (proto);
#line 47 "midori-uri.vala"
		if (_tmp9_ == NULL) {
#line 250 "midori-uri.c"
			char* _tmp10_;
#line 47 "midori-uri.vala"
			_tmp9_ = (_tmp10_ = g_strdup (""), _g_free0 (_tmp9_), _tmp10_);
#line 254 "midori-uri.c"
		}
		_tmp11_ = NULL;
#line 48 "midori-uri.vala"
		if (proto != NULL) {
#line 48 "midori-uri.vala"
			_tmp11_ = "://";
#line 261 "midori-uri.c"
		} else {
#line 48 "midori-uri.vala"
			_tmp11_ = "";
#line 265 "midori-uri.c"
		}
		result = (_tmp14_ = g_strconcat (_tmp13_ = g_strconcat (_tmp12_ = g_strconcat (_tmp9_, _tmp11_, NULL), encoded, NULL), path, NULL), _g_free0 (_tmp13_), _g_free0 (_tmp12_), _tmp14_);
		_g_free0 (_tmp9_);
		_g_free0 (encoded);
		_g_free0 (hostname);
		_g_free0 (_tmp7_);
		_g_free0 (path);
		_g_free0 (proto);
#line 47 "midori-uri.vala"
		return result;
#line 276 "midori-uri.c"
		_g_free0 (_tmp9_);
	}
	result = g_strdup (uri);
	_g_free0 (encoded);
	_g_free0 (hostname);
	_g_free0 (_tmp7_);
	_g_free0 (path);
	_g_free0 (proto);
#line 51 "midori-uri.vala"
	return result;
#line 287 "midori-uri.c"
}


#line 1181 "glib-2.0.vapi"
static char* string_replace (const char* self, const char* old, const char* replacement) {
#line 293 "midori-uri.c"
	char* result = NULL;
	GError * _inner_error_ = NULL;
#line 1181 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1181 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1181 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 302 "midori-uri.c"
	{
		char* _tmp0_;
		GRegex* _tmp1_;
		GRegex* regex;
		char* _tmp2_;
#line 1183 "glib-2.0.vapi"
		regex = (_tmp1_ = g_regex_new (_tmp0_ = g_regex_escape_string (old, -1), 0, 0, &_inner_error_), _g_free0 (_tmp0_), _tmp1_);
#line 310 "midori-uri.c"
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
#line 1184 "glib-2.0.vapi"
		_tmp2_ = g_regex_replace_literal (regex, self, (gssize) (-1), 0, replacement, 0, &_inner_error_);
#line 321 "midori-uri.c"
		if (_inner_error_ != NULL) {
			_g_regex_unref0 (regex);
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			_g_regex_unref0 (regex);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		result = _tmp2_;
		_g_regex_unref0 (regex);
#line 1184 "glib-2.0.vapi"
		return result;
#line 336 "midori-uri.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		{
#line 1186 "glib-2.0.vapi"
			g_assert_not_reached ();
#line 347 "midori-uri.c"
			_g_error_free0 (e);
		}
	}
	__finally0:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


#line 53 "midori-uri.vala"
char* midori_uri_unescape (const char* uri) {
#line 362 "midori-uri.c"
	char* result = NULL;
	gboolean _tmp0_ = FALSE;
#line 53 "midori-uri.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 55 "midori-uri.vala"
	if (g_utf8_strchr (uri, (gssize) (-1), (gunichar) '%') != NULL) {
#line 55 "midori-uri.vala"
		_tmp0_ = TRUE;
#line 371 "midori-uri.c"
	} else {
#line 55 "midori-uri.vala"
		_tmp0_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) ' ') != NULL;
#line 375 "midori-uri.c"
	}
#line 55 "midori-uri.vala"
	if (_tmp0_) {
#line 379 "midori-uri.c"
		char* unescaped;
#line 57 "midori-uri.vala"
		unescaped = g_uri_unescape_string (uri, "+");
#line 58 "midori-uri.vala"
		if (unescaped == NULL) {
#line 385 "midori-uri.c"
			result = g_strdup (uri);
			_g_free0 (unescaped);
#line 59 "midori-uri.vala"
			return result;
#line 390 "midori-uri.c"
		}
		result = string_replace (unescaped, " ", "%20");
		_g_free0 (unescaped);
#line 60 "midori-uri.vala"
		return result;
#line 396 "midori-uri.c"
	}
	result = g_strdup (uri);
#line 62 "midori-uri.vala"
	return result;
#line 401 "midori-uri.c"
}


#line 64 "midori-uri.vala"
char* midori_uri_format_for_display (const char* uri) {
#line 407 "midori-uri.c"
	char* result = NULL;
	gboolean _tmp0_ = FALSE;
#line 66 "midori-uri.vala"
	if (uri != NULL) {
#line 66 "midori-uri.vala"
		_tmp0_ = g_str_has_prefix (uri, "http://");
#line 414 "midori-uri.c"
	} else {
#line 66 "midori-uri.vala"
		_tmp0_ = FALSE;
#line 418 "midori-uri.c"
	}
#line 66 "midori-uri.vala"
	if (_tmp0_) {
#line 422 "midori-uri.c"
		char* unescaped;
		char* path;
		char* _tmp1_ = NULL;
		char* _tmp2_;
		char* _tmp3_;
		char* hostname;
		char* decoded;
#line 67 "midori-uri.vala"
		unescaped = midori_uri_unescape (uri);
#line 68 "midori-uri.vala"
		if (unescaped == NULL) {
#line 434 "midori-uri.c"
			result = g_strdup (uri);
			_g_free0 (unescaped);
#line 69 "midori-uri.vala"
			return result;
#line 439 "midori-uri.c"
		} else {
#line 70 "midori-uri.vala"
			if (!g_utf8_validate (unescaped, -1, NULL)) {
#line 443 "midori-uri.c"
				result = g_strdup (uri);
				_g_free0 (unescaped);
#line 71 "midori-uri.vala"
				return result;
#line 448 "midori-uri.c"
			}
		}
		path = NULL;
#line 73 "midori-uri.vala"
		hostname = (_tmp2_ = midori_uri_parse_hostname (unescaped, &_tmp1_), path = (_tmp3_ = _tmp1_, _g_free0 (path), _tmp3_), _tmp2_);
#line 74 "midori-uri.vala"
		decoded = g_hostname_to_unicode (hostname);
#line 75 "midori-uri.vala"
		if (decoded != NULL) {
#line 458 "midori-uri.c"
			char* _tmp4_;
			char* _tmp5_;
			result = (_tmp5_ = g_strconcat (_tmp4_ = g_strconcat ("http://", decoded, NULL), path, NULL), _g_free0 (_tmp4_), _tmp5_);
			_g_free0 (decoded);
			_g_free0 (hostname);
			_g_free0 (path);
			_g_free0 (unescaped);
#line 76 "midori-uri.vala"
			return result;
#line 468 "midori-uri.c"
		}
		result = unescaped;
		_g_free0 (decoded);
		_g_free0 (hostname);
		_g_free0 (path);
#line 77 "midori-uri.vala"
		return result;
#line 476 "midori-uri.c"
	}
	result = g_strdup (uri);
#line 79 "midori-uri.vala"
	return result;
#line 481 "midori-uri.c"
}


#line 81 "midori-uri.vala"
char* midori_uri_for_search (const char* uri, const char* keywords) {
#line 487 "midori-uri.c"
	char* result = NULL;
	char* escaped;
#line 81 "midori-uri.vala"
	g_return_val_if_fail (keywords != NULL, NULL);
#line 85 "midori-uri.vala"
	if (uri == NULL) {
#line 494 "midori-uri.c"
		result = g_strdup (keywords);
#line 86 "midori-uri.vala"
		return result;
#line 498 "midori-uri.c"
	}
#line 87 "midori-uri.vala"
	escaped = g_uri_escape_string (keywords, ":/", TRUE);
#line 89 "midori-uri.vala"
	if (_vala_strcmp0 (uri, "https://duckduckgo.com/?q=%s") == 0) {
#line 504 "midori-uri.c"
		result = g_strdup_printf ("https://duckduckgo.com/?q=%s&t=midori", escaped);
		_g_free0 (escaped);
#line 90 "midori-uri.vala"
		return result;
#line 509 "midori-uri.c"
	}
#line 91 "midori-uri.vala"
	if (strstr (uri, "%s") != NULL) {
#line 513 "midori-uri.c"
		result = g_strdup_printf (uri, escaped);
		_g_free0 (escaped);
#line 92 "midori-uri.vala"
		return result;
#line 518 "midori-uri.c"
	}
	result = g_strconcat (uri, escaped, NULL);
	_g_free0 (escaped);
#line 93 "midori-uri.vala"
	return result;
#line 524 "midori-uri.c"
}


#line 95 "midori-uri.vala"
gboolean midori_uri_is_blank (const char* uri) {
#line 530 "midori-uri.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 96 "midori-uri.vala"
	if (uri != NULL) {
#line 96 "midori-uri.vala"
		_tmp1_ = _vala_strcmp0 (uri, "") != 0;
#line 538 "midori-uri.c"
	} else {
#line 96 "midori-uri.vala"
		_tmp1_ = FALSE;
#line 542 "midori-uri.c"
	}
#line 96 "midori-uri.vala"
	if (_tmp1_) {
#line 96 "midori-uri.vala"
		_tmp0_ = !g_str_has_prefix (uri, "about:");
#line 548 "midori-uri.c"
	} else {
#line 96 "midori-uri.vala"
		_tmp0_ = FALSE;
#line 552 "midori-uri.c"
	}
	result = !_tmp0_;
#line 96 "midori-uri.vala"
	return result;
#line 557 "midori-uri.c"
}


#line 98 "midori-uri.vala"
gboolean midori_uri_is_http (const char* uri) {
#line 563 "midori-uri.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 99 "midori-uri.vala"
	if (uri != NULL) {
#line 568 "midori-uri.c"
		gboolean _tmp1_ = FALSE;
#line 100 "midori-uri.vala"
		if (g_str_has_prefix (uri, "http://")) {
#line 100 "midori-uri.vala"
			_tmp1_ = TRUE;
#line 574 "midori-uri.c"
		} else {
#line 100 "midori-uri.vala"
			_tmp1_ = g_str_has_prefix (uri, "https://");
#line 578 "midori-uri.c"
		}
#line 100 "midori-uri.vala"
		_tmp0_ = _tmp1_;
#line 582 "midori-uri.c"
	} else {
#line 99 "midori-uri.vala"
		_tmp0_ = FALSE;
#line 586 "midori-uri.c"
	}
	result = _tmp0_;
#line 99 "midori-uri.vala"
	return result;
#line 591 "midori-uri.c"
}


#line 102 "midori-uri.vala"
gboolean midori_uri_is_resource (const char* uri) {
#line 597 "midori-uri.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 103 "midori-uri.vala"
	if (uri != NULL) {
#line 602 "midori-uri.c"
		gboolean _tmp1_ = FALSE;
#line 104 "midori-uri.vala"
		if (midori_uri_is_http (uri)) {
#line 104 "midori-uri.vala"
			_tmp1_ = TRUE;
#line 608 "midori-uri.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 105 "midori-uri.vala"
			if (g_str_has_prefix (uri, "data:")) {
#line 105 "midori-uri.vala"
				_tmp2_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) ';') != NULL;
#line 615 "midori-uri.c"
			} else {
#line 105 "midori-uri.vala"
				_tmp2_ = FALSE;
#line 619 "midori-uri.c"
			}
#line 105 "midori-uri.vala"
			_tmp1_ = _tmp2_;
#line 623 "midori-uri.c"
		}
#line 104 "midori-uri.vala"
		_tmp0_ = _tmp1_;
#line 627 "midori-uri.c"
	} else {
#line 103 "midori-uri.vala"
		_tmp0_ = FALSE;
#line 631 "midori-uri.c"
	}
	result = _tmp0_;
#line 103 "midori-uri.vala"
	return result;
#line 636 "midori-uri.c"
}


#line 107 "midori-uri.vala"
gboolean midori_uri_is_location (const char* uri) {
#line 642 "midori-uri.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 109 "midori-uri.vala"
	if (uri != NULL) {
#line 647 "midori-uri.c"
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
#line 110 "midori-uri.vala"
		if (strstr (uri, "://") != NULL) {
#line 110 "midori-uri.vala"
			_tmp6_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) ' ') == NULL;
#line 658 "midori-uri.c"
		} else {
#line 110 "midori-uri.vala"
			_tmp6_ = FALSE;
#line 662 "midori-uri.c"
		}
#line 110 "midori-uri.vala"
		if (_tmp6_) {
#line 110 "midori-uri.vala"
			_tmp5_ = TRUE;
#line 668 "midori-uri.c"
		} else {
#line 111 "midori-uri.vala"
			_tmp5_ = midori_uri_is_http (uri);
#line 672 "midori-uri.c"
		}
#line 110 "midori-uri.vala"
		if (_tmp5_) {
#line 110 "midori-uri.vala"
			_tmp4_ = TRUE;
#line 678 "midori-uri.c"
		} else {
#line 112 "midori-uri.vala"
			_tmp4_ = g_str_has_prefix (uri, "about:");
#line 682 "midori-uri.c"
		}
#line 110 "midori-uri.vala"
		if (_tmp4_) {
#line 110 "midori-uri.vala"
			_tmp3_ = TRUE;
#line 688 "midori-uri.c"
		} else {
			gboolean _tmp7_ = FALSE;
#line 113 "midori-uri.vala"
			if (g_str_has_prefix (uri, "data:")) {
#line 113 "midori-uri.vala"
				_tmp7_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) ';') != NULL;
#line 695 "midori-uri.c"
			} else {
#line 113 "midori-uri.vala"
				_tmp7_ = FALSE;
#line 699 "midori-uri.c"
			}
#line 113 "midori-uri.vala"
			_tmp3_ = _tmp7_;
#line 703 "midori-uri.c"
		}
#line 110 "midori-uri.vala"
		if (_tmp3_) {
#line 110 "midori-uri.vala"
			_tmp2_ = TRUE;
#line 709 "midori-uri.c"
		} else {
			gboolean _tmp8_ = FALSE;
#line 114 "midori-uri.vala"
			if (g_str_has_prefix (uri, "geo:")) {
#line 114 "midori-uri.vala"
				_tmp8_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) ',') != NULL;
#line 716 "midori-uri.c"
			} else {
#line 114 "midori-uri.vala"
				_tmp8_ = FALSE;
#line 720 "midori-uri.c"
			}
#line 114 "midori-uri.vala"
			_tmp2_ = _tmp8_;
#line 724 "midori-uri.c"
		}
#line 110 "midori-uri.vala"
		if (_tmp2_) {
#line 110 "midori-uri.vala"
			_tmp1_ = TRUE;
#line 730 "midori-uri.c"
		} else {
#line 115 "midori-uri.vala"
			_tmp1_ = g_str_has_prefix (uri, "javascript:");
#line 734 "midori-uri.c"
		}
#line 110 "midori-uri.vala"
		_tmp0_ = _tmp1_;
#line 738 "midori-uri.c"
	} else {
#line 109 "midori-uri.vala"
		_tmp0_ = FALSE;
#line 742 "midori-uri.c"
	}
	result = _tmp0_;
#line 109 "midori-uri.vala"
	return result;
#line 747 "midori-uri.c"
}


#line 117 "midori-uri.vala"
gboolean midori_uri_is_email (const char* uri) {
#line 753 "midori-uri.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 118 "midori-uri.vala"
	if (uri != NULL) {
#line 759 "midori-uri.c"
		gboolean _tmp2_ = FALSE;
#line 119 "midori-uri.vala"
		if (g_utf8_strchr (uri, (gssize) (-1), (gunichar) '@') != NULL) {
#line 119 "midori-uri.vala"
			_tmp2_ = TRUE;
#line 765 "midori-uri.c"
		} else {
#line 119 "midori-uri.vala"
			_tmp2_ = g_str_has_prefix (uri, "mailto:");
#line 769 "midori-uri.c"
		}
#line 119 "midori-uri.vala"
		_tmp1_ = _tmp2_;
#line 773 "midori-uri.c"
	} else {
#line 118 "midori-uri.vala"
		_tmp1_ = FALSE;
#line 777 "midori-uri.c"
	}
#line 118 "midori-uri.vala"
	if (_tmp1_) {
#line 121 "midori-uri.vala"
		_tmp0_ = strstr (uri, "://") == NULL;
#line 783 "midori-uri.c"
	} else {
#line 118 "midori-uri.vala"
		_tmp0_ = FALSE;
#line 787 "midori-uri.c"
	}
	result = _tmp0_;
#line 118 "midori-uri.vala"
	return result;
#line 792 "midori-uri.c"
}


#line 123 "midori-uri.vala"
gboolean midori_uri_is_ip_address (const char* uri) {
#line 798 "midori-uri.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
#line 128 "midori-uri.vala"
	if (uri == NULL) {
#line 808 "midori-uri.c"
		result = FALSE;
#line 129 "midori-uri.vala"
		return result;
#line 812 "midori-uri.c"
	}
#line 131 "midori-uri.vala"
	if (g_unichar_isdigit (g_utf8_get_char (g_utf8_offset_to_pointer (uri, 0)))) {
#line 131 "midori-uri.vala"
		_tmp0_ = g_utf8_strchr (uri, (gssize) 4, (gunichar) '.') != NULL;
#line 818 "midori-uri.c"
	} else {
#line 131 "midori-uri.vala"
		_tmp0_ = FALSE;
#line 822 "midori-uri.c"
	}
#line 131 "midori-uri.vala"
	if (_tmp0_) {
#line 826 "midori-uri.c"
		result = TRUE;
#line 132 "midori-uri.vala"
		return result;
#line 830 "midori-uri.c"
	}
#line 134 "midori-uri.vala"
	if (g_unichar_isalnum (g_utf8_get_char (g_utf8_offset_to_pointer (uri, 0)))) {
#line 134 "midori-uri.vala"
		_tmp5_ = g_unichar_isalnum (g_utf8_get_char (g_utf8_offset_to_pointer (uri, 1)));
#line 836 "midori-uri.c"
	} else {
#line 134 "midori-uri.vala"
		_tmp5_ = FALSE;
#line 840 "midori-uri.c"
	}
#line 134 "midori-uri.vala"
	if (_tmp5_) {
#line 135 "midori-uri.vala"
		_tmp4_ = g_unichar_isalnum (g_utf8_get_char (g_utf8_offset_to_pointer (uri, 2)));
#line 846 "midori-uri.c"
	} else {
#line 134 "midori-uri.vala"
		_tmp4_ = FALSE;
#line 850 "midori-uri.c"
	}
#line 134 "midori-uri.vala"
	if (_tmp4_) {
#line 135 "midori-uri.vala"
		_tmp3_ = g_unichar_isalnum (g_utf8_get_char (g_utf8_offset_to_pointer (uri, 3)));
#line 856 "midori-uri.c"
	} else {
#line 134 "midori-uri.vala"
		_tmp3_ = FALSE;
#line 860 "midori-uri.c"
	}
#line 134 "midori-uri.vala"
	if (_tmp3_) {
#line 135 "midori-uri.vala"
		_tmp2_ = g_utf8_get_char (g_utf8_offset_to_pointer (uri, 4)) == ':';
#line 866 "midori-uri.c"
	} else {
#line 134 "midori-uri.vala"
		_tmp2_ = FALSE;
#line 870 "midori-uri.c"
	}
#line 134 "midori-uri.vala"
	if (_tmp2_) {
#line 874 "midori-uri.c"
		gboolean _tmp6_ = FALSE;
#line 136 "midori-uri.vala"
		if (g_utf8_get_char (g_utf8_offset_to_pointer (uri, 5)) == ':') {
#line 136 "midori-uri.vala"
			_tmp6_ = TRUE;
#line 880 "midori-uri.c"
		} else {
#line 136 "midori-uri.vala"
			_tmp6_ = g_unichar_isalnum (g_utf8_get_char (g_utf8_offset_to_pointer (uri, 5)));
#line 884 "midori-uri.c"
		}
#line 136 "midori-uri.vala"
		_tmp1_ = _tmp6_;
#line 888 "midori-uri.c"
	} else {
#line 134 "midori-uri.vala"
		_tmp1_ = FALSE;
#line 892 "midori-uri.c"
	}
#line 134 "midori-uri.vala"
	if (_tmp1_) {
#line 896 "midori-uri.c"
		result = TRUE;
#line 137 "midori-uri.vala"
		return result;
#line 900 "midori-uri.c"
	}
	result = FALSE;
#line 138 "midori-uri.vala"
	return result;
#line 905 "midori-uri.c"
}


#line 140 "midori-uri.vala"
gboolean midori_uri_is_valid (const char* uri) {
#line 911 "midori-uri.c"
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 141 "midori-uri.vala"
	if (uri != NULL) {
#line 142 "midori-uri.vala"
		_tmp1_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) ' ') == NULL;
#line 919 "midori-uri.c"
	} else {
#line 141 "midori-uri.vala"
		_tmp1_ = FALSE;
#line 923 "midori-uri.c"
	}
#line 141 "midori-uri.vala"
	if (_tmp1_) {
#line 927 "midori-uri.c"
		gboolean _tmp2_ = FALSE;
#line 143 "midori-uri.vala"
		if (midori_uri_is_location (uri)) {
#line 143 "midori-uri.vala"
			_tmp2_ = TRUE;
#line 933 "midori-uri.c"
		} else {
#line 143 "midori-uri.vala"
			_tmp2_ = g_utf8_strchr (uri, (gssize) (-1), (gunichar) '.') != NULL;
#line 937 "midori-uri.c"
		}
#line 143 "midori-uri.vala"
		_tmp0_ = _tmp2_;
#line 941 "midori-uri.c"
	} else {
#line 141 "midori-uri.vala"
		_tmp0_ = FALSE;
#line 945 "midori-uri.c"
	}
	result = _tmp0_;
#line 141 "midori-uri.vala"
	return result;
#line 950 "midori-uri.c"
}


static glong string_get_length (const char* self) {
	glong result;
	g_return_val_if_fail (self != NULL, 0L);
	result = g_utf8_strlen (self, (gssize) (-1));
#line 1194 "glib-2.0.vapi"
	return result;
#line 960 "midori-uri.c"
}


#line 145 "midori-uri.vala"
GChecksumType midori_uri_get_fingerprint (const char* uri, char** checksum, char** label) {
#line 966 "midori-uri.c"
	GChecksumType result = 0;
	const char* delimiter;
	const char* display;
	GChecksumType type;
	const char* fragment;
#line 145 "midori-uri.vala"
	g_return_val_if_fail (uri != NULL, 0);
#line 974 "midori-uri.c"
	if (checksum != NULL) {
		*checksum = NULL;
	}
	if (label != NULL) {
		*label = NULL;
	}
#line 149 "midori-uri.vala"
	delimiter = "#!md5!";
#line 150 "midori-uri.vala"
	display = _ ("MD5-Checksum:");
#line 151 "midori-uri.vala"
	type = G_CHECKSUM_MD5;
#line 152 "midori-uri.vala"
	fragment = strstr (uri, delimiter);
#line 153 "midori-uri.vala"
	if (fragment == NULL) {
#line 154 "midori-uri.vala"
		delimiter = "#!sha1!";
#line 155 "midori-uri.vala"
		display = _ ("SHA1-Checksum:");
#line 156 "midori-uri.vala"
		type = G_CHECKSUM_SHA1;
#line 157 "midori-uri.vala"
		fragment = strstr (uri, delimiter);
#line 999 "midori-uri.c"
	}
#line 159 "midori-uri.vala"
	if (fragment == NULL) {
#line 160 "midori-uri.vala"
		type = (GChecksumType) G_MAXINT;
#line 161 "midori-uri.vala"
		display = NULL;
#line 1007 "midori-uri.c"
	}
#line 164 "midori-uri.vala"
	if ((checksum) != NULL) {
#line 1011 "midori-uri.c"
		const char* _tmp0_;
		char* _tmp1_;
		_tmp0_ = NULL;
#line 165 "midori-uri.vala"
		if (fragment != NULL) {
#line 166 "midori-uri.vala"
			_tmp0_ = g_utf8_offset_to_pointer (fragment, string_get_length (delimiter));
#line 1019 "midori-uri.c"
		} else {
#line 166 "midori-uri.vala"
			_tmp0_ = NULL;
#line 1023 "midori-uri.c"
		}
#line 165 "midori-uri.vala"
		*checksum = (_tmp1_ = g_strdup (_tmp0_), _g_free0 (*checksum), _tmp1_);
#line 1027 "midori-uri.c"
	}
#line 167 "midori-uri.vala"
	if ((label) != NULL) {
#line 1031 "midori-uri.c"
		char* _tmp2_;
#line 168 "midori-uri.vala"
		*label = (_tmp2_ = g_strdup (display), _g_free0 (*label), _tmp2_);
#line 1035 "midori-uri.c"
	}
	result = type;
#line 169 "midori-uri.vala"
	return result;
#line 1040 "midori-uri.c"
}


#line 18 "midori-uri.vala"
MidoriURI* midori_uri_construct (GType object_type) {
#line 1046 "midori-uri.c"
	MidoriURI * self = NULL;
#line 18 "midori-uri.vala"
	self = (MidoriURI*) g_object_new (object_type, NULL);
#line 1050 "midori-uri.c"
	return self;
}


#line 18 "midori-uri.vala"
MidoriURI* midori_uri_new (void) {
#line 18 "midori-uri.vala"
	return midori_uri_construct (MIDORI_TYPE_URI);
#line 1059 "midori-uri.c"
}


static void midori_uri_class_init (MidoriURIClass * klass) {
	midori_uri_parent_class = g_type_class_peek_parent (klass);
}


static void midori_uri_instance_init (MidoriURI * self) {
}


GType midori_uri_get_type (void) {
	static volatile gsize midori_uri_type_id__volatile = 0;
	if (g_once_init_enter (&midori_uri_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MidoriURIClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) midori_uri_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MidoriURI), 0, (GInstanceInitFunc) midori_uri_instance_init, NULL };
		GType midori_uri_type_id;
		midori_uri_type_id = g_type_register_static (G_TYPE_OBJECT, "MidoriURI", &g_define_type_info, 0);
		g_once_init_leave (&midori_uri_type_id__volatile, midori_uri_type_id);
	}
	return midori_uri_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




